/*
 * elf.c
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


enum{EI_NIDENT 16};

typedef unsigned int Elf32_Addr;
typedef unsigned short Elf32_Half;
typedef unsigned int Elf32_Off;
typedef int Elf32_Sword;
typedef unsigned int Elf32_Word;


/* ELF Header define valus */
enum{
	/* e_type */
	ET_REL=	1,		/* Relocatable file */
	ET_EXEC=2,		/* Executable file */
	ET_DYN=	3,		/* Shared object file */

	/* e_machine */
	EM_386=3,		/* Intel 80386 */

	P_HEDDER_SIZE=32	/* vOwb_[TCYB */
};

/* ELF Header */
typedef struct{
	unsigned char e_ident[EI_NIDENT];
	Elf32_Half e_type;					/* t@C^CvB */
	Elf32_Half e_machine;				/* cpuA[LeN`B */
	Elf32_Word e_version;
	Elf32_Addr e_entry;					/* Gg[[AhXB */
	Elf32_Off e_phoff;					/* vOwb_[t@CItZbgB */
	Elf32_Off e_shoff;
	Elf32_Word e_flags;
	Elf32_Half e_ehsize;
	Elf32_Half e_phentsize;
	Elf32_Half e_phnum;					/* vOwb_[B */
	Elf32_Half e_shentsize;
	Elf32_Half e_shnum;
	Elf32_Half e_shstrndx;
}Elf32_Ehdr;

char magic_number[]={0x7f,'E','L','F','\0'};

/* Program Header */
typedef struct{
	Elf32_Word p_type;		/* ZOg^CvB */
	Elf32_Off p_offset;		/* t@CItZbgB */
	Elf32_Addr p_vaddr;		/* [AhXB */
	Elf32_Addr p_paddr;
	Elf32_Word p_filesz;	/* ZOgTCY */
	Elf32_Word p_memsz;
	Elf32_Word p_flags;		/* ZOgtOB */
	Elf32_Word p_align;
}Elf32_Phdr;
